<template>
    <form class="form" @submit="submitAccessForm">
        <p class="form-title">
            <slot></slot>
        </p>
        <img class="form-close"
             src="/assets/img/close.png"
             alt=""
             @click="onCloseForm"
        >
        <label class="form-group"
               :class="(accessData.name.valid === '') ? '' : accessData.name.valid"
        >
            <p>{{ local.name[$lang] }}</p>
            <input type="text" name="name"
                   :placeholder="local.name[$lang]"
                   required
                   v-model="accessData.name.value">
        </label>

        <label class="form-group"
               :class="(accessData.email.valid === '') ? '' : accessData.email.valid"
        >
            <p>{{ local.email[$lang] }}</p>
            <input type="text" name="email"
                   :placeholder="local.email[$lang]"
                   required
                   v-model="accessData.email.value">
        </label>

        <label class="form-group"
                :class="(accessData.phone.valid === '') ? '' : accessData.phone.valid"
        >
            <p>{{ local.phone[$lang] }}</p>
            <input type="text" name="name"
                   :placeholder="local.phone[$lang]"
                   required
                   v-model="accessData.phone.value">
        </label>

        <label class="form-group"
                :class="(accessData.msg.valid === '') ? '' : accessData.msg.valid"
        >
            <p>{{ local.message[$lang] }}</p>
            <input type="text" name="name"
                   :placeholder="local.message[$lang]"
                   required
                   v-model="accessData.msg.value">
        </label>

        <label class="form-group_checkbox">
            <input type="checkbox" name="agreement" v-model="accessData.agreement.value">
            <img v-if="accessData.agreement.value" src="/assets/img/checkbox_active.png" alt="">
            <img v-else src="/assets/img/checkbox_active_no.png" alt="">
            <p>{{ local.agreement[$lang] }}</p>
        </label>

        <input class="form-submit" type="submit" value="Отправить">
    </form>
</template>

<script>
    import local from '../../localisation/modals/accessFormLocalisation.js';

    export default {
        data: () => ({
            local,
            accessData: {
                name: {
                    value: '',
                    regexpTest: '^[a-zA-Z]+$',
                    valid: ''
                },
                email: {
                    value: '',
                    regexpTest: '([a-zA-Z0-9_\\.\\-])+\\@(([a-zA-Z0-9\\-])+)+(\\.[a-zA-Z0-9]{2,6}){1,3}',
                    valid: ''
                },
                phone: {
                    value: '',
                    regexpTest: '\\+\[0-9]{0,19}',
                    valid: ''
                },
                msg: {
                    value: '',
                    regexpTest: '',
                    valid: ''
                },
                agreement: {
                    value: false,
                    regexpTest: ''
                }
            },
            unvalidFields: 0
        }),
        methods: {
            onCloseForm() {
                this.$emit('formClosedEvent');
            },
            submitAccessForm(e) {
                e.preventDefault();
                this.unvalidFields = 0;
                for (let item in this.accessData) {
                    // (!!this.accessData[item].value === false) ? this.unvalidFields++ : false;
                    if (item !== 'agreement') {
                        let regexp = new RegExp(this.accessData[item].regexpTest);
                        let value = this.accessData[item].value.replace(/\s/g, '');
                        if (value === ''|| this.accessData[item].value === '' || !regexp.test(value)) {
                            console.log(item, '', regexp.test(value))
                            this.accessData[item].valid = 'unvalid';
                            this.unvalidFields++;
                        }
                        else {
                            this.accessData[item].valid = 'valid';
                        }
                    }
                    else {
                        (!!this.accessData[item].value === false) ? this.unvalidFields++ : false;
                    }
                }
                (this.unvalidFields === 0) ? this.$emit('switchToSuccessModal') : false;
            }
        }
    }
</script>

<style lang="scss" scoped>


    .form {
        background-color: #fff;
        width: 100%;
        max-width: 670px;
        border-radius: 8px;
        padding: 63px 100px 61px;
        position: relative;
        @media(max-width: 620px){
                padding: 36px 15px 40px;
                margin: 10px;

        }
        &-title {
            width: 234px;
            height: 30px;
            font-family: OpenSans;
            font-size: 18px;
            text-transform: uppercase;
            line-height: 1.67;
            color: #83919c;
            margin-bottom: 35px;
            @media(max-width: 620px){
                font-size: 14px ;
             }
        }
        &-close {
            position: absolute;
            top: 68px;
            right: 100px;
            display: block!important;
             @media(max-width: 620px){
                right: 40px;
                 top: 35px;
             }
            &:hover {
                cursor: pointer;
            }
        }
        &-group {
            display: flex;
            flex-wrap: wrap;
            align-content: flex-end;
            height: 50px;
            &:not(:last-of-type) {
                margin-bottom: 20px;
            }
            p {
                height: 18px;
                /*font-family: FuturaPT;*/
                font-size: 14px;
                color: #afc3d3;
                margin-bottom: 5px;
                 @media(max-width: 620px){
                font-size: 10px ;
             }
            }
            input {
                width: 100%;
                height: 26px;
                outline: none;
                font-size: 16px;
                color: #333333;
                border: none;
                border-bottom: 1px solid  #d1dde6;
                transition: all 0.3s;
                 @media(max-width: 620px){
                    font-size: 12px ;
                 }
                &::-webkit-input-placeholder {
                    font-size: inherit;
                    color: inherit;
                }
                &:focus {
                    border-bottom-color: #95c11f;
                }
            }
        }
        &-group_checkbox {
            display: flex;
            align-items: flex-start;
            margin-top: 40px;
            &:hover {
                cursor: pointer;
            } 
            p {
                height: 52px;
                /*font-family: FuturaPT;*/
                font-size: 16px;
                line-height: 1.63;
                color: #333333;
                margin-left: 10px;
                margin-top: -5px;
                user-select: none;
                 @media(max-width: 620px){
                    font-size: 12px ;
                 }
            }
            input {
                display: none;
                visibility: hidden;
                @media screen and ( -ms-high-contrast: active), (-ms-high-contrast: none) {
                   position: absolute;
                   opacity: 0;
                   width: 14px;
                   height: 14px;
                   display: block;
                   visibility: visible;
                }
            }
            img {
                width: 14px;
                height: 14px;
                min-width: 14px;
            }
        }
        &-submit {
            border: none;
            outline: none;
            width: 177.9px;
            margin-top: 37px;
            text-transform: uppercase;
            height: 52px;
            border-radius: 50px;
            background-image: linear-gradient(to right, #dedc00, #95c11f);
            font-family: 'Comfortaa', sans-serif;
            font-size: 14px;
            font-weight: bold;
            letter-spacing: 1px;
            color: #ffffff;
        }
    }
    .true_access_form {
        max-width: 576px;
        padding-top: 36px;
        .form-close {
            top: 38px;
            @media(max-width: 768px){
                top: 24px;
                right: 15px;
            }
        }
        @media(max-width: 768px){
            font-size: 12px ;
            padding: 25px 15px;
        }
    }

    .valid {
        border-bottom: 1px solid #95C11F;
        input {
            color: #95C11F;
        }
    }
    .unvalid {
        border-bottom: 1px solid red;
        input {
            color: red;
        }
    }
</style>
